#!/usr/bin/env python
import tarfile, os, sys, getopt
"""
fname = 'test.tar'
dname = 'test'
th = tarfile.open(fname, "w")
path = os.path.join(os.getcwd(), dname)
os.chdir(path)
for foo in os.listdir(path):
    th.add(foo)
th.close()
"""
def usage():
    print "Makes a tar file from the contents of a directory."
    print "Requires 2 args: -d for the input directory -f for the output filename."
def main(argv=None):
    if argv is None:
        argv = sys.argv[1:]
    try:
        opts, args = getopt.getopt(argv, "hgbd:f:", ["help","gzip","bz2","dir=", "file="])
    except getopt.GetoptError:
        usage()
        sys.exit(2)
        
    print opts
    path = os.getcwd()
    
    fname = None
    dir = None
    for opt, arg in opts:
        if opt in ('-h','--help'):
            usage()
        if opt in ('-d','--dir'):
            dir = arg
        if opt in ('-f','--file'):
            fname = arg
    
    if not fname or not dir:
        fname = 'resources.tar'
        dir = os.path.join(os.getcwd(),'Resources')
    path = os.path.join(path, dir)

    tar = tarfile.open(fname, "w")
    os.chdir(path)
    for file in os.listdir(path):
        if not os.path.isdir(file):
            print file
            tar.add(file)
    tar.close()
        
if __name__ == "__main__":
    main(sys.argv[1:])