from actor import *
import unpack
from math import *
from vector import *
import random
anims=unpack.unpack('Resources','resources.tar')

classVector=['SpikeBall',
             'Wand',
             'Bat']


class SpikeBall(Actor):
    def __init__(self,engine,**kw):
        Actor.__init__(self,engine)
        self.bounds=pygame.Rect(-10,-10,20,20)
        self.image=anims['spikeball'][0]

        self.image[0].set_colorkey((255,0,255),pygame.RLEACCEL)
        self.position=(12*32,43*32)
        self.drawPosition=self.position
        self.enemy=True
        self.damage=150
        #origin defaults to top,left
        self.__dict__.update(kw)
    
    #def think(self):
     #   actor.Actor.think(self)
    
class Wand(Actor):
    def __init__(self,engine,**kw):
        Actor.__init__(self,engine)
        self.bounds=pygame.Rect(-16,-16,32,32)
        self.image=anims['wand'][0]

        self.image[0].set_colorkey((255,0,255),pygame.RLEACCEL)
        self.position=(12*32,43*32)
        self.drawPosition=self.position
        self.enemy=False
        self.damage=150
        #origin defaults to top,left
        self.__dict__.update(kw)
    
    #def think(self):
     #   actor.Actor.think(self)
    def onCollide(self,other):
        print "Magic Wand Stolen!"
        self.engine.finishedLevel1=True
        self.engine.playerSprite.gotWand=True
        
class Bat(Actor):
    def __init__(self,engine,**kw):
        Actor.__init__(self,engine)
        self.bounds=pygame.Rect(-16,-16,32,32)
        self.frames=anims['bat']
        [f[0].set_colorkey((255,0,255)) for f in self.frames]
        self.image=anims['bat'][0]

        #self.image[0].set_colorkey((255,0,255),pygame.RLEACCEL)
        self.position=(12*32,43*32)
        self.drawPosition=self.position
        self.enemy=True
        self.damage=10
        self.speed=3
        self.xrange=150.0
        self.yrange=60.0

        #origin defaults to top,left
        self.__dict__.update(kw)
        self.tickoff=int(round(random.random()*1000))

    def think(self):
        Actor.think(self)
        self.image=self.frames[(self.tick/5)%2]
        yv=self.speed*sin(self.speed*(self.tickoff+self.tick)/self.yrange)
        xv=self.speed*cos(self.speed*(self.tickoff+self.tick)/self.xrange)
        self.position=addv(self.position,(xv,yv))
        